#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<time.h>
int pocet_radku(FILE *f)
{
     int pocet = 0;
     int c;
     while ((c = getc(f)) != EOF) {
          if (c == '\n')
          pocet++;
          }
     return pocet;
     }
int pocet_tabelatoru(FILE *f)
{
     int pocet = 0;
     int c;
     while ((c = getc(f)) != EOF) {
           if (c == '\n' || c == '\t'){
              pocet++;
              }
           }
     return pocet;
     }
int main (void) {
    FILE *f;
    char jmeno_souboru_vysledky[3];
    char pocet_povodi_MD[43]; char dist_MD[40]; char data_andy_MD[45]; char andy_graf_MD[47]; char nazev_vazene_parametry_MD[48]; char celkove_odchylky_MD[65];
    char pocet_povodi_CE[43]; char dist_CE[40]; char data_andy_CE[45]; char andy_graf_CE[47]; char nazev_vazene_parametry_CE[48]; char celkove_odchylky_CE[65];            
    double **pole_parametru, **pole_nenormovanych_deskriptoru_povodi, **pole_normovanych_deskriptoru_povodi;
    int **pole_kombinace_nastaveni_programu;
    double **pole_parametru_podminka_CE, **pole_max_diferenci_UNGAGE_GAGE, **pole_Andy_podminka_max_dif;
    double **pole_vybranych_normovanych_deskriptoru_povodi, *deskriptory_UNGAGE, **deskriptory_GAGE, **vzdalenosti_UNGAGE_GAGE; 
    double **pole_deskriptoru_GAGE_povodi_podminka, **pole_Andy, **pole_OF, **pole_OF_podminka, **pole_Andy_podminka_CE;
    double **pole_max_diferenci_UNGAGE_GAGE_podminka, **pole_parametru_podminka_MD;
    double *pole_vazeneho_prumeru_MD, *pole_odchylek_MD;
    double *pole_diferenci_UNGAGE_GAGE, *pole_vazeneho_prumeru, *pole_UNGAGE_parametru, *pole_odchylek;   
    int odmocnina_ano_ne, testovany_pocet_deskriptoru, pocet_radku_kombinaci_nastaveni, pocet_radku_parametru;
    int pocet_tabelatoru_parametru, pocet_parametru_modelu, pocet_radku_nenorm_deskriptoru_povodi, pocet_tabelatoru_nenorm_deskriptoru_povodi;
    int max_pocet_sloupcu_deskriptoru_povodi, typ_standardizace, pocet_radku_norm_deskriptoru_povodi;
    double soucet_nenorm_deskriptoru, prumer_deskriptoru, suma_ctvercu, smer_odchylka;
    double soucet_deskriptoru, radiusvektor, minimalni_vzdalenost, vazeny_parametr, suma_vzdalenosti;
    int jina_merika, pocet_minimalnich_vzdalenosti, pocet_lepsich_CE, vyber_reseni, pocet_mensich_max_odchylek;
    int vyber_poctu_povodi, pocet_analyzovanych_povodi, pocet_radku_vybranych_povodi;
    double rozdil_deskriptoru, typ_metriky;
    double soucin_ungage_gage, soucet_ungage, soucet_gage, maximalni_vzdalenost, zjistena_maximalni_vzdalenost, citatel;
    double jmenovatel, suma_zlomku, suma_citatele, suma_jmenovatele;
    double clen_1_ungage, clen_2_ungage, clen_3_ungage, clen_pomoc_ungage;
    double clen_1_gage, clen_2_gage, clen_3_gage, clen_pomoc_gage;
    double minimum_extrem, maximum_extrem, mezni_vzdalenost, CE_porov, prahova_max_diference;
    double suma_1, suma_2, suma_3, prumer_1;
    int a, b, c, d, e, g, h, i, j, k, l, m, n;  
    /*nacteni nastaveni shlukovani*/
    f = fopen ("settings/settings_clus.txt","r");
    if (f == NULL) {
       printf ("file settings_clus.txt not found\n");
       system ("PAUSE");
       return 1;
       }
    fscanf (f, "%d %lf %d %lf %d %lf %lf %d %d", &jina_merika, &typ_metriky, &odmocnina_ano_ne, &mezni_vzdalenost, &vyber_reseni, &CE_porov, &prahova_max_diference, &vyber_poctu_povodi, &pocet_analyzovanych_povodi);
    fclose(f);    
    if (vyber_poctu_povodi == 1) {
       printf ("pocitam vsechna povodi\n");
       }
    if (vyber_poctu_povodi == 2) {
       printf ("pocitam pouze %d povodi\n", pocet_analyzovanych_povodi);
       }        
    printf ("typ metriky: %.0f\t odmocneni ve vypoctu: %d\n", typ_metriky, odmocnina_ano_ne);
    printf ("X-nasobek: %.2f\t mezni vzdalenost: %f\t mezni CE: %.3f\n", mezni_vzdalenost, prahova_max_diference, CE_porov);
    printf ("typ pouzite metriky: %d\n", jina_merika);
    if (jina_merika == 1) {
       printf ("reseni dle Minkowskeho metriky\n");
       }
    if (jina_merika == 2) {
       printf ("reseni dle Kosinove metriky\n");
       }
    if (jina_merika == 3) {
       printf ("reseni dle Chebysevovy metriky\n");
       }
    if (jina_merika == 4) {
       printf ("reseni dle Canberrske metriky\n");
       }
    if (jina_merika == 5) {
       printf ("reseni dle Bray-Curtisovy metriky\n");
       }
    /*zjisteni poctu radku souboru s parametry modelu*/    
    f = fopen ("input_data/parametry_modelu.txt", "r");
    if (f == NULL) {
       printf ("file parametry_modelu.txt not found\n");
       system ("PAUSE");
       return 1;
       }
    pocet_radku_parametru = pocet_radku(f);
    fclose(f);
    printf ("pocet povodi v souboru parametry_modelu.txt: %d\n", pocet_radku_parametru);
    /*zjisteni poctu sloupcu souboru s parametry modelu*/    
    f = fopen ("input_data/parametry_modelu.txt", "r");
    if (f == NULL) {
       printf ("file parametry_modelu.txt not found\n");
       system ("PAUSE");
       return 1;
       }
    pocet_tabelatoru_parametru = pocet_tabelatoru(f);
    fclose(f);    
    pocet_parametru_modelu = (pocet_tabelatoru_parametru / pocet_radku_parametru) - 1;
    printf ("pocet parametru modelu: %d\n", pocet_parametru_modelu);
    /*zjisteni poctu radku souboru s nenormovanymi deskriptory povodi*/ 
    f = fopen ("input_data/nenorm_deskriptory_povodi.txt", "r");
    if (f == NULL) {
       printf ("file nenorm_deskriptory_povodi.txt not found\n");
       system ("PAUSE");
       return 1;
       }
    pocet_radku_nenorm_deskriptoru_povodi = pocet_radku(f);
    fclose(f);
    printf ("pocet povodi v souboru nenorm_deskriptory_povodi.txt: %d\n", pocet_radku_nenorm_deskriptoru_povodi);
    /*zjisteni poctu sloupcu souboru s nenormovanymi deskriptory povodi*/ 
    f = fopen ("input_data/nenorm_deskriptory_povodi.txt", "r");
    if (f == NULL) {
       printf ("file nenorm_deskriptory_povodi not.txt found\n");
       system ("PAUSE");
       return 1;
       }
    pocet_tabelatoru_nenorm_deskriptoru_povodi = pocet_tabelatoru(f);
    fclose(f);
    max_pocet_sloupcu_deskriptoru_povodi = (pocet_tabelatoru_nenorm_deskriptoru_povodi / pocet_radku_nenorm_deskriptoru_povodi) - 1;    
    printf ("celkovy pocet deskriptoru povodi v souboru nenorm_deskriptory_povodi.txt: %d\n", max_pocet_sloupcu_deskriptoru_povodi);
    /*alokace dvourozmerneho pole parametru modelu a nacteni parametru do tohoto pole*/
    if ((pole_parametru = ((double**) malloc(pocet_radku_parametru * sizeof(double *)))) == NULL) {
       printf ("chyba pri alokaci pameti\n");
       return 1;
       }
     for (a = 0; a < pocet_radku_parametru; a++) {
         if ((pole_parametru[a] = ((double*) malloc((pocet_parametru_modelu + 1) * sizeof(double)))) == NULL) {
            printf("chyba pri alokaci pameti\n");
            return 1;
            }
         }
     f = fopen ("input_data/parametry_modelu.txt", "r");
     for (a = 0; a < pocet_radku_parametru; a++) {
         for (b = 0; b < (pocet_parametru_modelu + 1); b++) {
             fscanf (f,"%lf", &pole_parametru[a][b]);
             }
         }
     fclose(f);
     /*alokace dvourozmerneho pole nenormovanych deskriptoru a nacteni deskriptoru do tohoto pole*/
     if ((pole_nenormovanych_deskriptoru_povodi = ((double**) malloc(pocet_radku_nenorm_deskriptoru_povodi * sizeof(double *)))) == NULL) {
       printf ("chyba pri alokaci pameti\n");
       return 1;
       }
     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
         if ((pole_nenormovanych_deskriptoru_povodi[c] = ((double*) malloc((max_pocet_sloupcu_deskriptoru_povodi + 1) * sizeof(double)))) == NULL) {
            printf("chyba pri alokaci pameti\n");
            return 1;
            }
         }
     f = fopen ("input_data/nenorm_deskriptory_povodi.txt", "r");
     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
         for (d = 0; d < (max_pocet_sloupcu_deskriptoru_povodi + 1); d++) {
             fscanf (f,"%lf", &pole_nenormovanych_deskriptoru_povodi[c][d]);
             }
         }
     fclose(f);
     /*kontrola vstupnich dat*/
     if (pocet_radku_parametru > pocet_radku_nenorm_deskriptoru_povodi) {
        printf ("pocet radku souboru parametry_modelu.txt > pocet radku souboru nenorm_deskriptory_povodi.txt\n");
        for (a = 0; a < pocet_radku_parametru; a++) {        
            int pravda = 0;
            for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++){
                if (pole_parametru[a][0] == pole_nenormovanych_deskriptoru_povodi[c][0]) {
                    pravda = 1;                   
                   }            
                }
            if (pravda == 0) {
               f  = fopen ("errors/chybove_hlaseni.txt", "a");
               fprintf (f, "toto povodi chybi v souboru nenorm_deskriptory_povodi.txt: %.0f\n", pole_parametru[a][0]);
               fclose (f);
               }
            }
        for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++){
            int pravda = 0;
            for (a = 0; a < pocet_radku_parametru; a++) {
                if (pole_nenormovanych_deskriptoru_povodi[c][0] == pole_parametru[a][0]) {
                    pravda = 1;                   
                   }            
                }
            if (pravda == 0) {
               f  = fopen ("errors/chybove_hlaseni.txt", "a");
               fprintf (f, "toto povodi chybi v souboru parametry_modelu.txt: %.0f\n", pole_nenormovanych_deskriptoru_povodi[c][0]);
               fclose (f);
               }
            }
        }
     if (pocet_radku_nenorm_deskriptoru_povodi > pocet_radku_parametru) {
        printf ("pocet radku souboru nenorm_deskriptory_povodi.txt > pocet radku souboru parametry_modelu.txt\n");
        for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++){
            int pravda = 0;
            for (a = 0; a < pocet_radku_parametru; a++) {
                if (pole_nenormovanych_deskriptoru_povodi[c][0] == pole_parametru[a][0]) {
                    pravda = 1;                   
                   }            
                }
            if (pravda == 0) {
               f  = fopen ("errors/chybove_hlaseni.txt", "a");
               fprintf (f, "toto povodi chybi v souboru parametry_modelu.txt: %.0f\n", pole_nenormovanych_deskriptoru_povodi[c][0]);
               fclose (f);
               }
            }
        for (a = 0; a < pocet_radku_parametru; a++) {        
            int pravda = 0;
            for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++){
                if (pole_parametru[a][0] == pole_nenormovanych_deskriptoru_povodi[c][0]) {
                    pravda = 1;                   
                   }            
                }
            if (pravda == 0) {
               f  = fopen ("errors/chybove_hlaseni.txt", "a");
               fprintf (f, "toto povodi chybi v souboru nenorm_deskriptory_povodi.txt: %.0f\n", pole_parametru[a][0]);
               fclose (f);
               }
            }
        }
     if (pocet_radku_nenorm_deskriptoru_povodi == pocet_radku_parametru) {
        for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++){
            int pravda = 0;
            for (a = 0; a < pocet_radku_parametru; a++) {
                if (pole_nenormovanych_deskriptoru_povodi[c][0] == pole_parametru[a][0]) {
                    pravda = 1;                   
                   }            
                }
            if (pravda == 0) {
               f  = fopen ("errors/chybove_hlaseni.txt", "a");
               fprintf (f, "toto povodi chybi v souboru parametry_modelu.txt: %.0f\n", pole_nenormovanych_deskriptoru_povodi[c][0]);
               fclose (f);                              
               }            
            }
        for (a = 0; a < pocet_radku_parametru; a++) {        
            int pravda = 0;
            for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++){
                if (pole_parametru[a][0] == pole_nenormovanych_deskriptoru_povodi[c][0]) {
                    pravda = 1;                   
                   }            
                }
            if (pravda == 0) {
               f  = fopen ("errors/chybove_hlaseni.txt", "a");
               fprintf (f, "toto povodi chybi v souboru nenorm_deskriptory_povodi.txt: %.0f\n", pole_parametru[a][0]);
               fclose (f);                              
               }                                      
            }
        }
     f = fopen ("errors/chybove_hlaseni.txt", "r");
     if (f != NULL) {
       printf ("chybove hlaseni\n");
       system ("PAUSE");
       return 1;
       }
     /*nacteni kombinace deskriptoru*/
     f = fopen ("settings/settings_deskriptory.txt", "r");
     if (f == NULL) {
       printf ("file settings_deskriptory.txt not found\n");
       system ("PAUSE");
       return 1;
       }
     fscanf (f, "%d %d", &testovany_pocet_deskriptoru, &typ_standardizace);
     fclose (f);
     printf ("testovane n-tice deskriptoru, kde n=%d\n", testovany_pocet_deskriptoru);
     f = fopen ("settings/kombinace_deskriptoru.txt", "r");
     if (f == NULL) {
       printf ("file kombinace_deskriptoru.txt not found\n");
       system ("PAUSE");
       return 1;
       }
     pocet_radku_kombinaci_nastaveni = pocet_radku(f);
     fclose (f);
     if ((pole_kombinace_nastaveni_programu = ((int**) malloc(pocet_radku_kombinaci_nastaveni * sizeof(int *)))) == NULL) {
       printf ("chyba pri alokaci pameti\n");
       return 1;
       }
     for (e = 0; e < pocet_radku_kombinaci_nastaveni; e++) {
         if ((pole_kombinace_nastaveni_programu[e] = ((int*) malloc(testovany_pocet_deskriptoru * sizeof(int)))) == NULL) {
            printf("chyba pri alokaci pameti\n");
            return 1;
            }
         }
     f = fopen ("settings/kombinace_deskriptoru.txt", "r");
     for (e = 0; e < pocet_radku_kombinaci_nastaveni; e++) {
         for (g = 0; g < testovany_pocet_deskriptoru; g++) {
             fscanf (f,"%d", &pole_kombinace_nastaveni_programu[e][g]);
             }
         }
     fclose(f);
     /*standardizace deskriptoru*/
     pocet_radku_norm_deskriptoru_povodi = pocet_radku_nenorm_deskriptoru_povodi;
     if ((pole_normovanych_deskriptoru_povodi = ((double**) malloc(pocet_radku_norm_deskriptoru_povodi * sizeof(double *)))) == NULL) {
         printf ("chyba pri alokaci pameti\n");
         return 1;
         }
     for (c = 0; c < pocet_radku_norm_deskriptoru_povodi; c++) {
         if ((pole_normovanych_deskriptoru_povodi[c] = ((double*) malloc((max_pocet_sloupcu_deskriptoru_povodi + 1) * sizeof(double)))) == NULL) {
            printf("chyba pri alokaci pameti\n");
            return 1;
            }
         }
     switch (typ_standardizace) {                            
            case 1:
                 for (c = 0; c < pocet_radku_norm_deskriptoru_povodi; c++) {
                     pole_normovanych_deskriptoru_povodi[c][0] = pole_nenormovanych_deskriptoru_povodi[c][0];
                     }
                 for (d = 1; d < (max_pocet_sloupcu_deskriptoru_povodi + 1); d++) {
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         pole_normovanych_deskriptoru_povodi[c][d] = pole_nenormovanych_deskriptoru_povodi[c][d];
                         }
                     }
                 break;
            case 2:
                 for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                     pole_normovanych_deskriptoru_povodi[c][0] = pole_nenormovanych_deskriptoru_povodi[c][0];
                     }
                 for (d = 1; d < (max_pocet_sloupcu_deskriptoru_povodi + 1); d++) {
                     double maximalni_hodnota_deskriptoru = 0;
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         if (pole_nenormovanych_deskriptoru_povodi[c][d] > maximalni_hodnota_deskriptoru) {
                            maximalni_hodnota_deskriptoru = pole_nenormovanych_deskriptoru_povodi[c][d];
                            }
                         }
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         pole_normovanych_deskriptoru_povodi[c][d] = pole_nenormovanych_deskriptoru_povodi[c][d] / maximalni_hodnota_deskriptoru;
                         }                                                                 
                     }
                 break;
            case 3:
                 for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                     pole_normovanych_deskriptoru_povodi[c][0] = pole_nenormovanych_deskriptoru_povodi[c][0];
                     }
                 for (d = 1; d < (max_pocet_sloupcu_deskriptoru_povodi + 1); d++) {
                     double maximalni_hodnota_deskriptoru = 0;
                     double minimalni_hodnota_deskriptoru = 100000;
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         if (pole_nenormovanych_deskriptoru_povodi[c][d] > maximalni_hodnota_deskriptoru) {
                            maximalni_hodnota_deskriptoru = pole_nenormovanych_deskriptoru_povodi[c][d];
                            }
                         if (pole_nenormovanych_deskriptoru_povodi[c][d] < minimalni_hodnota_deskriptoru) {
                            minimalni_hodnota_deskriptoru = pole_nenormovanych_deskriptoru_povodi[c][d];
                            }
                         }
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         pole_normovanych_deskriptoru_povodi[c][d] = pole_nenormovanych_deskriptoru_povodi[c][d] / (maximalni_hodnota_deskriptoru - minimalni_hodnota_deskriptoru);
                         }                                                                 
                     }                                         
                 break;
            case 4:
                 for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                     pole_normovanych_deskriptoru_povodi[c][0] = pole_nenormovanych_deskriptoru_povodi[c][0];
                     }
                 for (d = 1; d < (max_pocet_sloupcu_deskriptoru_povodi + 1); d++) {
                     double maximalni_hodnota_deskriptoru = 0;
                     double minimalni_hodnota_deskriptoru = 100000;
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         if (pole_nenormovanych_deskriptoru_povodi[c][d] > maximalni_hodnota_deskriptoru) {
                            maximalni_hodnota_deskriptoru = pole_nenormovanych_deskriptoru_povodi[c][d];
                            }
                         if (pole_nenormovanych_deskriptoru_povodi[c][d] < minimalni_hodnota_deskriptoru) {
                            minimalni_hodnota_deskriptoru = pole_nenormovanych_deskriptoru_povodi[c][d];
                            }
                         }
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         pole_normovanych_deskriptoru_povodi[c][d] = (pole_nenormovanych_deskriptoru_povodi[c][d] - minimalni_hodnota_deskriptoru) / (maximalni_hodnota_deskriptoru - minimalni_hodnota_deskriptoru);
                         }                                                                 
                     }                                         
                 break;
            case 5:
                 for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                     pole_normovanych_deskriptoru_povodi[c][0] = pole_nenormovanych_deskriptoru_povodi[c][0];
                     }
                 for (d = 1; d < (max_pocet_sloupcu_deskriptoru_povodi + 1); d++) {
                     soucet_nenorm_deskriptoru = prumer_deskriptoru = suma_ctvercu = 0;
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         soucet_nenorm_deskriptoru = soucet_nenorm_deskriptoru + pole_nenormovanych_deskriptoru_povodi[c][d];
                         }
                     if (soucet_nenorm_deskriptoru == 0) {
                        prumer_deskriptoru = 0;
                        }   
                     else prumer_deskriptoru = soucet_nenorm_deskriptoru / pocet_radku_nenorm_deskriptoru_povodi;
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         suma_ctvercu = suma_ctvercu + pow ((pole_nenormovanych_deskriptoru_povodi[c][d] - prumer_deskriptoru), 2);
                         }
                     if (suma_ctvercu == 0) {
                        smer_odchylka = 0;
                        }   
                     else smer_odchylka = pow (( suma_ctvercu / pocet_radku_nenorm_deskriptoru_povodi), 0.5);
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         if (smer_odchylka == 0)
                            pole_normovanych_deskriptoru_povodi[c][d] = 0;   
                         else pole_normovanych_deskriptoru_povodi[c][d] = pole_nenormovanych_deskriptoru_povodi[c][d] / smer_odchylka;
                         }
                     }
                 break;                 
            case 6:
                 for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                     pole_normovanych_deskriptoru_povodi[c][0] = pole_nenormovanych_deskriptoru_povodi[c][0];
                     }
                 for (d = 1; d < (max_pocet_sloupcu_deskriptoru_povodi + 1); d++) {
                     soucet_nenorm_deskriptoru = prumer_deskriptoru = suma_ctvercu = 0;
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         soucet_nenorm_deskriptoru = soucet_nenorm_deskriptoru + pole_nenormovanych_deskriptoru_povodi[c][d];
                         }
                     if (soucet_nenorm_deskriptoru == 0) {
                        prumer_deskriptoru = 0;
                        }   
                     else prumer_deskriptoru = soucet_nenorm_deskriptoru / pocet_radku_nenorm_deskriptoru_povodi;
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         suma_ctvercu = suma_ctvercu + pow ((pole_nenormovanych_deskriptoru_povodi[c][d] - prumer_deskriptoru), 2);
                         }
                     if (suma_ctvercu == 0) {
                        smer_odchylka = 0;
                        }   
                     else smer_odchylka = pow (( suma_ctvercu / pocet_radku_nenorm_deskriptoru_povodi), 0.5);
                     for (c = 0; c < pocet_radku_nenorm_deskriptoru_povodi; c++) {
                         if (smer_odchylka == 0)
                         pole_normovanych_deskriptoru_povodi[c][d] = 0;   
                         else pole_normovanych_deskriptoru_povodi[c][d] = (pole_nenormovanych_deskriptoru_povodi[c][d] - prumer_deskriptoru) / smer_odchylka;
                         }
                     }
                 break;                  
            }
     /*alokace pole pro vybrane deskriptory*/
     if ((pole_vybranych_normovanych_deskriptoru_povodi = ((double**) malloc(pocet_radku_norm_deskriptoru_povodi * sizeof(double *)))) == NULL) {
        printf ("chyba pri alokaci pameti\n");
        return 1;
        }
     for (c = 0; c < pocet_radku_norm_deskriptoru_povodi; c++) {
         if ((pole_vybranych_normovanych_deskriptoru_povodi[c] = ((double*) malloc((testovany_pocet_deskriptoru + 1) * sizeof(double)))) == NULL) {
            printf("chyba pri alokaci pameti\n");
            return 1;
            }
         }
     /*alokace poli pro vyber UNGAGE a GAGE povodi*/     
     if ((deskriptory_UNGAGE = ((double*) malloc((testovany_pocet_deskriptoru + 1) * sizeof(double)))) == NULL) {
        printf ("chyba pri alokaci pameti\n");
        return 1;
        }
     if ((deskriptory_GAGE = ((double**) malloc((pocet_radku_norm_deskriptoru_povodi - 1) * sizeof(double *)))) == NULL) {
        printf ("chyba pri alokaci pameti\n");
        return 1;
        }
     for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
         if ((deskriptory_GAGE[h] = ((double*) malloc((testovany_pocet_deskriptoru + 1) * sizeof(double)))) == NULL) {
            printf("chyba pri alokaci pameti\n");
            return 1;
            }
         }
     /*vypocet vzdalenosti GAGE od UNGAGE a ulozeti techto vzdalenosti do pole*/
     if ((vzdalenosti_UNGAGE_GAGE = ((double**) malloc((pocet_radku_norm_deskriptoru_povodi - 1) * sizeof(double *)))) == NULL) {
        printf ("chyba pri alokaci pameti\n");
        return 1;
        }
     for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
         if ((vzdalenosti_UNGAGE_GAGE[h] = ((double*) malloc(2 * sizeof(double)))) == NULL) {
            printf("chyba pri alokaci pameti\n");
            return 1;
            }
         }     
     /*vyber sloupcu deskriptoru k analyze na zaklade nastaveni z kombinace_deskriptoru.txt*/
     for (e = 0; e < pocet_radku_kombinaci_nastaveni; e++) {
         printf ("prave pocitam kombinaci deskriptoru: \n");
         for (g = 0; g < testovany_pocet_deskriptoru; g++) {
             printf ("%d\t", pole_kombinace_nastaveni_programu[e][g]);
             }
         printf ("\n");
         sprintf (jmeno_souboru_vysledky, "md output_data\\output_data_%d", e + 1);         
         system (jmeno_souboru_vysledky);                  
         for (c = 0; c < pocet_radku_norm_deskriptoru_povodi; c++) {
             pole_vybranych_normovanych_deskriptoru_povodi[c][0] = pole_normovanych_deskriptoru_povodi[c][0]; 
             }
         for (c = 0; c < pocet_radku_norm_deskriptoru_povodi; c++) {
             for (g = 1; g < (testovany_pocet_deskriptoru + 1); g++) {
                 pole_vybranych_normovanych_deskriptoru_povodi[c][g] = pole_normovanych_deskriptoru_povodi[c][pole_kombinace_nastaveni_programu[e][g - 1]];
                 }
             }
                    
         for (g = 1; g < (testovany_pocet_deskriptoru + 1); g++) {
             for (c = 0; c < pocet_radku_norm_deskriptoru_povodi; c++) {
                 pole_vybranych_normovanych_deskriptoru_povodi[c][g] = pole_normovanych_deskriptoru_povodi[c][pole_kombinace_nastaveni_programu[e][g - 1]];
                 }
             }        
         /*vyber nepozorovaneho povodi*/         
         if (vyber_poctu_povodi == 1) {
            pocet_radku_vybranych_povodi = pocet_radku_norm_deskriptoru_povodi;
            }
         if (vyber_poctu_povodi == 2) {
            pocet_radku_vybranych_povodi = pocet_analyzovanych_povodi;
            } 
         for (c = 0; c < pocet_radku_vybranych_povodi; c++) {                                      
             for (h = 0; h < pocet_radku_norm_deskriptoru_povodi; h++) {
                 if (h == c) {
                    for (g = 0; g < (testovany_pocet_deskriptoru + 1); g++) {                                                
                        deskriptory_UNGAGE[g] = pole_vybranych_normovanych_deskriptoru_povodi[h][g];
                        }
                    printf ("\n");
                    }                 
                 if (h < c) {
                    for (g = 0; g < (testovany_pocet_deskriptoru + 1); g++) {
                        deskriptory_GAGE[h][g] = pole_vybranych_normovanych_deskriptoru_povodi[h][g];
                        }
                    }
                 if (h > c) {
                    for (g = 0; g < (testovany_pocet_deskriptoru + 1); g++) {
                        deskriptory_GAGE[h - 1][g] = pole_vybranych_normovanych_deskriptoru_povodi[h][g];
                        }                        
                    }
                 }                                                                                
             printf ("pocitam povodi: %.0f\n", deskriptory_UNGAGE[0]);
             if (jina_merika == 1) {
                for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
                    vzdalenosti_UNGAGE_GAGE[h][0] = deskriptory_GAGE[h][0]; 
                    radiusvektor = 0;
                    for (g = 1; g < (testovany_pocet_deskriptoru + 1); g++) {                     
                        rozdil_deskriptoru = fabs (deskriptory_UNGAGE[g] - deskriptory_GAGE[h][g]);
                        radiusvektor = radiusvektor + pow (rozdil_deskriptoru, typ_metriky);                     
                        }                 
                    if (odmocnina_ano_ne == 1) {
                       vzdalenosti_UNGAGE_GAGE[h][1] = pow (radiusvektor, 1 / typ_metriky);
                       }
                    if (odmocnina_ano_ne == 2) {
                       vzdalenosti_UNGAGE_GAGE[h][1] = radiusvektor;
                       }                                                                                                                              
                    }
                }
             if (jina_merika == 2) {
                for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
                    vzdalenosti_UNGAGE_GAGE[h][0] = deskriptory_GAGE[h][0];
                    soucin_ungage_gage = soucet_ungage = soucet_gage = 0;
                    for (g = 1; g < (testovany_pocet_deskriptoru + 1); g++) {
                        soucin_ungage_gage = soucin_ungage_gage + deskriptory_UNGAGE[g] * deskriptory_GAGE[h][g];                        
                        soucet_ungage = soucet_ungage + pow (deskriptory_UNGAGE[g], 2);
                        soucet_gage = soucet_gage + pow (deskriptory_GAGE[h][g], 2);
                        }
                    vzdalenosti_UNGAGE_GAGE[h][1] = 1 - soucin_ungage_gage / (soucet_ungage * soucet_gage);
                    }
                }
             if (jina_merika == 3) {
                for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
                    vzdalenosti_UNGAGE_GAGE[h][0] = deskriptory_GAGE[h][0];
                    maximalni_vzdalenost = zjistena_maximalni_vzdalenost = 0;
                    for (g = 1; g < (testovany_pocet_deskriptoru + 1); g++) {
                        zjistena_maximalni_vzdalenost = fabs (deskriptory_UNGAGE[g] - deskriptory_GAGE[h][g]);                        
                        if (zjistena_maximalni_vzdalenost > maximalni_vzdalenost) {
                           maximalni_vzdalenost = zjistena_maximalni_vzdalenost;
                           }    
                        }
                    vzdalenosti_UNGAGE_GAGE[h][1] = maximalni_vzdalenost;                          
                    }
                }
             if (jina_merika == 4) {
                for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
                    vzdalenosti_UNGAGE_GAGE[h][0] = deskriptory_GAGE[h][0];
                    suma_zlomku = 0;
                    for (g = 1; g < (testovany_pocet_deskriptoru + 1); g++) {                        
                        citatel = fabs (deskriptory_UNGAGE[g] - deskriptory_GAGE[h][g]);
                        jmenovatel = fabs (deskriptory_UNGAGE[g]) + fabs (deskriptory_GAGE[h][g]);
                        suma_zlomku = suma_zlomku + (citatel / jmenovatel);                                       
                        }
                    vzdalenosti_UNGAGE_GAGE[h][1] = suma_zlomku;                          
                    }
                }
             if (jina_merika == 5) {
                for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
                    vzdalenosti_UNGAGE_GAGE[h][0] = deskriptory_GAGE[h][0];
                    suma_citatele = suma_jmenovatele = 0;
                    for (g = 1; g < (testovany_pocet_deskriptoru + 1); g++) {                        
                        suma_citatele = suma_citatele + fabs (deskriptory_UNGAGE[g] - deskriptory_GAGE[h][g]);
                        suma_jmenovatele = suma_jmenovatele + fabs (deskriptory_UNGAGE[g] + deskriptory_GAGE[h][g]);                                       
                        }
                    vzdalenosti_UNGAGE_GAGE[h][1] = suma_citatele / suma_jmenovatele;                          
                    }
                }                                                                                                      
             minimalni_vzdalenost = 10000000;
             for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
                 if (vzdalenosti_UNGAGE_GAGE[h][1] < minimalni_vzdalenost) {
                    minimalni_vzdalenost = vzdalenosti_UNGAGE_GAGE[h][1];
                    }
                 }
             printf ("minimalni vzdalenost: %f\n", minimalni_vzdalenost);
             pocet_minimalnich_vzdalenosti = 0;
             for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
                 if (vzdalenosti_UNGAGE_GAGE[h][1] <= mezni_vzdalenost *  minimalni_vzdalenost) {
                    pocet_minimalnich_vzdalenosti++;
                    }
                 }
             printf ("pocet minimalnich vzdalenoti: %d\n", pocet_minimalnich_vzdalenosti);
             /*alokace dvourozmerneho pole, kam budou ulozeny GAGE povodi s jejich deskriptory se vzdalenosti mensi nez X*minimalni zjistena vzdalenost*/
             if ((pole_deskriptoru_GAGE_povodi_podminka = ((double**) malloc(pocet_minimalnich_vzdalenosti * sizeof(double *)))) == NULL) {
                printf ("chyba pri alokaci pameti\n");
                return 1;
                }
             for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                 if ((pole_deskriptoru_GAGE_povodi_podminka[i] = ((double*) malloc((testovany_pocet_deskriptoru + 1) * sizeof(double)))) == NULL) {
                    printf("chyba pri alokaci pameti\n");
                    return 1;
                    }
                 }
             i = 0;
             for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
                 if (i > pocet_minimalnich_vzdalenosti){
                    break;
                    }
                 if (vzdalenosti_UNGAGE_GAGE[h][1] <= mezni_vzdalenost *  minimalni_vzdalenost) {
                    for (g = 0; g < (testovany_pocet_deskriptoru + 1); g++) {
                        pole_deskriptoru_GAGE_povodi_podminka[i][g] = deskriptory_GAGE[h][g];
                        }
                    i++;
                    }                                          
                 }                                                     
             /*alokace dvourozmerneho pole pro vypocet Andrewsovych krivek*/
             if ((pole_Andy = ((double**) malloc(201 * sizeof(double *)))) == NULL) {
                printf ("chyba pri alokaci pameti\n");
                return 1;
                }
             for (j = 0; j < 201; j++) {
                 if ((pole_Andy[j] = ((double*) malloc((pocet_minimalnich_vzdalenosti + 2) * sizeof(double)))) == NULL) {
                    printf("chyba pri alokaci pameti\n");
                    return 1;
                    }
                 }             
             double x = -3.1714;
             for (j = 0; j < 201; j++) {
                 x = x + 0.0314;
                 pole_Andy[j][0] = x;
                 }
             for (j = 0; j < 201; j++) {
                 clen_1_ungage = (deskriptory_UNGAGE[1] / pow (2, 0.5));
                 clen_2_ungage = clen_3_ungage = clen_pomoc_ungage = 0;
                 for (g = 2; g < (testovany_pocet_deskriptoru + 1); g = g + 2) {
                     clen_2_ungage = (deskriptory_UNGAGE[g] * sin ((g / 2) * pole_Andy[j][0]));
                     if (g + 1 < (testovany_pocet_deskriptoru + 1)) {
                        clen_3_ungage = (deskriptory_UNGAGE[g + 1] * cos ((g / 2) * pole_Andy[j][0]));
                        }
                     clen_pomoc_ungage = clen_pomoc_ungage + clen_2_ungage + clen_3_ungage;
                     }
                 pole_Andy[j][1] = clen_1_ungage + clen_pomoc_ungage;
                 }
             for (j = 0; j < 201; j++) {
                 for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {                 
                     clen_1_gage = (pole_deskriptoru_GAGE_povodi_podminka[i][1] / pow (2, 0.5));
                     clen_2_gage = clen_3_gage = clen_pomoc_gage = 0;
                     for (g = 2; g < (testovany_pocet_deskriptoru + 1); g = g + 2) {
                         clen_2_gage = (pole_deskriptoru_GAGE_povodi_podminka[i][g] * sin ((g / 2) * pole_Andy[j][0]));
                         if (g + 1 < (testovany_pocet_deskriptoru + 1)) {
                            clen_3_gage = (pole_deskriptoru_GAGE_povodi_podminka[i][g + 1] * cos ((g / 2) * pole_Andy[j][0]));
                            }
                         clen_pomoc_gage = clen_pomoc_gage + clen_2_gage + clen_3_gage;
                         }
                     pole_Andy[j][i + 2] = clen_1_gage + clen_pomoc_gage;
                     }
                 }                                                                                                                                                                                                            
             for (i = 1; i < (pocet_minimalnich_vzdalenosti + 2); i++) { 
                 minimum_extrem = 0;
                 for (j = 0; j < 201; j++) {
                     if (pole_Andy[j][i] < minimum_extrem) {
                        minimum_extrem = pole_Andy[j][i];
                        }
                     }
                 for (j = 0; j < 201; j++) {
                     pole_Andy[j][i] = pole_Andy[j][i] + (minimum_extrem * -1.0);
                     } 
                 }
             maximum_extrem = 0;
             for (i = 1; i < (pocet_minimalnich_vzdalenosti + 2); i++) {
                 for (j = 0; j < 201; j++) {
                     if (pole_Andy[j][i] > maximum_extrem) {
                        maximum_extrem = pole_Andy[j][i];
                        }
                     }
                 }
             for (i = 1; i < (pocet_minimalnich_vzdalenosti + 2); i++) {
                  for (j = 0; j < 201; j++) {
                      pole_Andy[j][i] = pole_Andy[j][i] / maximum_extrem;
                      }
                  }
             /*reseni podle max odchylky Andyho krivky GAGE od Andyho krivky UNGAGE*/
             switch (vyber_reseni) {
                    case 1:                         
                         //printf ("reseni dle max diference\n");
                         /*alokace pole pro vypocet diferenci mezi Andy krivkou UNGAGE a ANDY krivkou GAGE a jeho plneni*/
                         if ((pole_diferenci_UNGAGE_GAGE = ((double*) malloc(201 * sizeof(double)))) == NULL) {
                            printf("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         /*alokace pole pro maximalni diferenci + ID povodi*/
                         if ((pole_max_diferenci_UNGAGE_GAGE = ((double**) malloc(pocet_minimalnich_vzdalenosti * sizeof(double *)))) == NULL) {
                            printf ("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             if ((pole_max_diferenci_UNGAGE_GAGE[i] = ((double*) malloc(3 * sizeof(double)))) == NULL) {
                                printf("chyba pri alokaci pameti\n");
                                return 1;
                                }
                             }
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             for (j = 0; j < 201; j++) {
                                 pole_diferenci_UNGAGE_GAGE[j] = pole_Andy[j][1] - pole_Andy[j][i + 2];
                                 if (pole_diferenci_UNGAGE_GAGE[j] < 0) {
                                    pole_diferenci_UNGAGE_GAGE[j] = pole_diferenci_UNGAGE_GAGE[j] * -1.0;
                                    }
                                 }
                             double maximalni_diference_UNGAGE_GAGE = 0;
                             for (j = 0; j < 201; j++) {
                                 if (maximalni_diference_UNGAGE_GAGE < pole_diferenci_UNGAGE_GAGE[j]) {
                                    maximalni_diference_UNGAGE_GAGE = pole_diferenci_UNGAGE_GAGE[j];
                                    }   
                                 }
                             pole_max_diferenci_UNGAGE_GAGE[i][0] = pole_deskriptoru_GAGE_povodi_podminka[i][0];
                             for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
                                 if (pole_max_diferenci_UNGAGE_GAGE[i][0] == vzdalenosti_UNGAGE_GAGE[h][0]) {
                                    pole_max_diferenci_UNGAGE_GAGE[i][1] = vzdalenosti_UNGAGE_GAGE[h][1];
                                    }
                                 }
                             pole_max_diferenci_UNGAGE_GAGE[i][2] = maximalni_diference_UNGAGE_GAGE;
                             }
                         pocet_mensich_max_odchylek = 0;
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             if (pole_max_diferenci_UNGAGE_GAGE[i][2] < prahova_max_diference) {
                                pocet_mensich_max_odchylek++;
                                }
                             }
                         printf ("pocet povodi s max odchylkou %f\t: %d\n", prahova_max_diference, pocet_mensich_max_odchylek);
                         /*tisk souboru s poctem prirazenych povodi splnujicich podminku MD*/
                         sprintf (pocet_povodi_MD, "output_data\\output_data_%d\\pocet_povodi_MD.txt", e + 1);
                         f = fopen (pocet_povodi_MD, "a");
                         fprintf (f, "%.0f\t %d\n",deskriptory_UNGAGE[0], pocet_mensich_max_odchylek);
                         fclose(f);
                         /*alokace pole pro tisk GAGE povodi splnujicich podminku MD a nacteni dat do nej*/
                         if ((pole_max_diferenci_UNGAGE_GAGE_podminka = ((double**) malloc(pocet_mensich_max_odchylek * sizeof(double *)))) == NULL) {
                            printf ("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         for (k = 0; k < pocet_mensich_max_odchylek; k++) {
                             if ((pole_max_diferenci_UNGAGE_GAGE_podminka[k] = ((double*) malloc(3 * sizeof(double)))) == NULL) {
                                printf("chyba pri alokaci pameti\n");
                                return 1;
                                }
                             }
                         k = 0;
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             if (k > pocet_mensich_max_odchylek){
                                break;
                                }
                             if (pole_max_diferenci_UNGAGE_GAGE[i][2] < prahova_max_diference) {
                                for (j = 0; j < 3; j++) {
                                    pole_max_diferenci_UNGAGE_GAGE_podminka[k][j] = pole_max_diferenci_UNGAGE_GAGE[i][j];
                                    }
                                k++;
                                }                                          
                             }
                         /*tisk vzdalenosti a max. diference do souboru vzdalenosti_MD_XXXXXXXXX.txt*/
                         sprintf (dist_MD, "output_data\\output_data_%d\\distance_MD_%.0f.txt", e + 1, deskriptory_UNGAGE[0]);
                         f = fopen (dist_MD, "w");
                         for (k = 0; k < pocet_mensich_max_odchylek; k++) {
                             for (j = 0; j < 3; j++) {
                                 fprintf (f, "%f\t", pole_max_diferenci_UNGAGE_GAGE_podminka[k][j]);
                                 }
                             fprintf (f, "\n");
                             }
                         fclose(f);                                      
                         /*alokace pole pro Andy krivky povodi splnujicich podminku prahova_max_diference*/
                         if ((pole_Andy_podminka_max_dif = ((double**) malloc(201 * sizeof(double *)))) == NULL) {
                            printf ("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         for (j = 0; j < 201; j++) {
                             if ((pole_Andy_podminka_max_dif[j] = ((double*) malloc((pocet_mensich_max_odchylek + 2) * sizeof(double)))) == NULL) {
                                printf("chyba pri alokaci pameti\n");
                                return 1;
                                }
                             }                                                                                                         
                         for (j = 0; j < 201; j++) {
                             pole_Andy_podminka_max_dif[j][0] = pole_Andy[j][0];
                             pole_Andy_podminka_max_dif[j][1] = pole_Andy[j][1];
                             }
                         k = 0;
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             if (k > pocet_mensich_max_odchylek){
                                break;
                                }    
                             if (pole_max_diferenci_UNGAGE_GAGE[i][2] < prahova_max_diference) {
                                for (j = 0; j < 201; j++) {
                                    pole_Andy_podminka_max_dif[j][k + 2] = pole_Andy[j][i + 2];
                                    }
                                k++;    
                                }                                                    
                             }                                                 
                         /*tisk dat pro Andrewsovy krivky do souboru data_pro_andy_MD_XXXXXXXXXX.txt*/
                         sprintf (data_andy_MD, "output_data\\output_data_%d\\data_pro_andy_MD_%.0f.txt", e + 1, deskriptory_UNGAGE[0]);
                         f = fopen (data_andy_MD, "w");
                         for (j = 0; j < 201; j++) {
                             for (k = 0; k < (pocet_mensich_max_odchylek + 2); k++) {
                                 fprintf (f, "%.3f\t", pole_Andy_podminka_max_dif[j][k]);
                                 }
                             fprintf (f, "\n");
                             } 
                         fclose(f);
                         /*alokace pole pro parametry modelu povodi splnujicich podminku OF pro vypocet vazeneho prumeru*/
                         if ((pole_parametru_podminka_MD = ((double**) malloc(pocet_mensich_max_odchylek * sizeof(double *)))) == NULL) {
                            printf ("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         for (k = 0; k < pocet_mensich_max_odchylek; k++) {
                             if ((pole_parametru_podminka_MD[k] = ((double*) malloc((pocet_parametru_modelu + 1) * sizeof(double)))) == NULL) {
                                printf("chyba pri alokaci pameti\n");
                                return 1;
                                }
                             }
                         for (a = 0; a < pocet_radku_parametru; a++) {
                             for (b = 0; b < (pocet_parametru_modelu + 1); b++) {
                                 for (k = 0; k < pocet_mensich_max_odchylek; k++) {
                                     pole_parametru_podminka_MD[k][0] = pole_max_diferenci_UNGAGE_GAGE_podminka[k][0];
                                     if (pole_parametru_podminka_MD[k][0] == pole_parametru[a][0]) {                          
                                        for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                                            pole_parametru_podminka_MD[k][b] = pole_parametru[a][b];
                                            }
                                        }                         
                                     }
                                 }
                             }
                         /*vytvoreni jednorozmerneho pole, kam budou nacteny vazene prumery parametru a vlastni vypocet vazeneho prumeru*/
                         if ((pole_vazeneho_prumeru_MD = ((double*) malloc((pocet_parametru_modelu + 1) * sizeof(double)))) == NULL) {
                            printf("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         pole_vazeneho_prumeru_MD[0] = deskriptory_UNGAGE[0];
                         for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                             vazeny_parametr = suma_vzdalenosti = 0;
                             for (k = 0; k < pocet_mensich_max_odchylek; k++) {
                                 if (pole_max_diferenci_UNGAGE_GAGE_podminka[k][1] == 0) {
                                    pole_max_diferenci_UNGAGE_GAGE_podminka[k][1] = 0.000000000001;
                                    }   
                                 vazeny_parametr = vazeny_parametr + (pole_parametru_podminka_MD[k][b] * (1 / pole_max_diferenci_UNGAGE_GAGE_podminka[k][1]));
                                 suma_vzdalenosti = suma_vzdalenosti + (1 / pole_max_diferenci_UNGAGE_GAGE_podminka[k][1]);
                                 }
                             pole_vazeneho_prumeru_MD[b] = vazeny_parametr / suma_vzdalenosti;
                             }
                         /*ulozeni sady optimalnich parametru a vypoctene sady parametru jako vazeny prumer do txt souboru XXX_vazene_parametry_MD.txt*/
                         sprintf (nazev_vazene_parametry_MD, "output_data\\output_data_%d\\%.0f_vazene_parametry_MD.txt", e + 1, deskriptory_UNGAGE[0]);
                         f = fopen (nazev_vazene_parametry_MD, "w");
                         fprintf (f, "optimalni hodnoty parametru modelu pro toto nepozorovane povodi\n");            
                         for (a = 0; a < pocet_radku_parametru; a++) {
                             if (pole_parametru[a][0] == deskriptory_UNGAGE[0]) {
                                for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                                    fprintf(f, "%.4f\t", pole_parametru[a][b]);
                                    }
                                }
                             }             
                         fprintf(f, "\n");                           
                         fprintf (f, "hodnoty parametru modelu vypoctene jako vazeny prumer pro toto nepozorovane povodi\n");             
                         for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                             fprintf(f, "%.4f\t", pole_vazeneho_prumeru_MD[b]);
                             }
                         fprintf(f, "\n");
                         fclose (f);
                         /*vypocet a tisk odchylek parametru VP od optimalnich hodnot*/
                         if ((pole_UNGAGE_parametru = ((double*) malloc((pocet_parametru_modelu + 1) * sizeof(double)))) == NULL) {
                            printf("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         if ((pole_odchylek_MD = ((double*) malloc((pocet_parametru_modelu + 1) * sizeof(double)))) == NULL) {
                            printf("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         pole_UNGAGE_parametru[0] = deskriptory_UNGAGE[0];
                         pole_odchylek_MD[0] = deskriptory_UNGAGE[0];
                         for (a = 0; a < pocet_radku_parametru; a++) {
                             if (pole_parametru[a][0] == pole_UNGAGE_parametru[0]) {
                                for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                                    pole_UNGAGE_parametru[b] = pole_parametru[a][b];
                                    }
                                }
                             }
                         for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                             pole_odchylek_MD[b] = (pole_vazeneho_prumeru_MD[b] / pole_UNGAGE_parametru[b]) * 100 - 100;
                             if (pole_odchylek_MD[b] < 0) {
                                pole_odchylek_MD[b] = pole_odchylek_MD[b] * -1.0;
                                }
                             }
                         sprintf (celkove_odchylky_MD, "output_data\\output_data_%d\\odchylky_pro_vsechna_ungage_povodi_MD.txt", e + 1);
                         f = fopen (celkove_odchylky_MD, "a");
                         for (b = 0; b < (pocet_parametru_modelu + 1); b++) {
                             fprintf (f, "%.4f\t", pole_odchylek_MD[b]);
                             }
                         fprintf (f, "\n");
                         fclose (f);      
                         /*vytvoreni GNU souboru pro vykreselni Andrewsovych krivek pro MD*/
                         sprintf (andy_graf_MD, "output_data\\output_data_%d\\%.f_AND_krivky_graf_MD.GNU", e + 1, deskriptory_UNGAGE[0]);
                         f = fopen (andy_graf_MD, "w");
                         fprintf (f, "set grid\n");
                         fprintf (f,"set key samplen 1\n");
                         fprintf (f,"set key width 0.05\n");
                         fprintf (f,"set key height 0.5\n");
                         fprintf (f,"set key outside below\n");
                         fprintf (f,"set xrange [-3.14:3.14]\n");
                         fprintf (f,"set xtics %f\n", 3.14 / 5);
                         fprintf (f,"plot 'C:\\invers_shluk\\output_data\\output_data_%d\\data_pro_andy_MD_%.0f.txt' u 1:3 w steps title 'gauged catchments' lt 9\n", e + 1, deskriptory_UNGAGE[0]);
                         for (i = 4; i < (pocet_mensich_max_odchylek + 3); i++) {
                             fprintf (f,"replot 'C:\\invers_shluk\\output_data\\output_data_%d\\data_pro_andy_MD_%.0f.txt' u 1:%d w steps title '' lt 9\n", e + 1, deskriptory_UNGAGE[0], i);
                             }    
                         fprintf (f,"replot 'C:\\invers_shluk\\output_data\\output_data_%d\\data_pro_andy_MD_%.0f.txt' u 1:2 w steps title 'ungauged catchment' lt -1 lw 2\n", e + 1, deskriptory_UNGAGE[0]);         
                         fprintf (f, "set out '%.f_AND_krivky_graf_MD.ps'\n", deskriptory_UNGAGE[0]);
                         fprintf (f, "set t post solid enhanced color\n");
                         fprintf (f, "replot\n");
                         fprintf (f, "set out\n");
                         fprintf (f, "set t windows\n");
                         fclose(f);
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             free((void*) pole_max_diferenci_UNGAGE_GAGE[i]);
                             }
                         free((void*) pole_max_diferenci_UNGAGE_GAGE); 
                         pole_max_diferenci_UNGAGE_GAGE = NULL;
                         for (k = 0; k < pocet_mensich_max_odchylek; k++) {
                             free((void*) pole_max_diferenci_UNGAGE_GAGE_podminka[k]);
                             }
                         free((void*) pole_max_diferenci_UNGAGE_GAGE_podminka); 
                         pole_max_diferenci_UNGAGE_GAGE_podminka = NULL;
                         for (j = 0; j < 201; j++) {
                             free((void*) pole_Andy_podminka_max_dif[j]);
                             }
                         free((void*) pole_Andy_podminka_max_dif); 
                         pole_Andy_podminka_max_dif = NULL;
                         for (k = 0; k < pocet_mensich_max_odchylek; k++) {
                             free((void*) pole_parametru_podminka_MD[k]);
                             }
                         free((void*) pole_parametru_podminka_MD); 
                         pole_parametru_podminka_MD = NULL;                                                                                                    
                         free((void*) pole_diferenci_UNGAGE_GAGE); 
                         pole_diferenci_UNGAGE_GAGE = NULL;
                         free((void*) pole_vazeneho_prumeru_MD); 
                         pole_vazeneho_prumeru_MD = NULL;
                         free((void*) pole_UNGAGE_parametru); 
                         pole_UNGAGE_parametru = NULL;
                         free((void*) pole_odchylek_MD); 
                         pole_odchylek_MD = NULL;
                         break;
                    case 2:
                         printf ("reseni dle CE\n");                    
                         /*reseni podle koeficientu determinace vypocteneho mezi Andyho krivkou UNGAGE a Andyho krivkami GAGE*/
                         /*alokace pole pro OF a vzdalenosti a vypocet OF*/
                         if ((pole_OF = ((double**) malloc(pocet_minimalnich_vzdalenosti * sizeof(double *)))) == NULL) {
                            printf ("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             if ((pole_OF[i] = ((double*) malloc(3 * sizeof(double)))) == NULL) {
                                printf("chyba pri alokaci pameti\n");
                                return 1;
                                }
                             }
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             for (h = 0; h < (pocet_radku_norm_deskriptoru_povodi - 1); h++) {
                                 if (pole_deskriptoru_GAGE_povodi_podminka[i][0] == vzdalenosti_UNGAGE_GAGE[h][0]) {
                                    pole_OF[i][0] = vzdalenosti_UNGAGE_GAGE[h][0];
                                    pole_OF[i][1] = vzdalenosti_UNGAGE_GAGE[h][1];
                                    }
                                 }
                             }                                                    
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             suma_1 = suma_2 = suma_3 = prumer_1 = 0;
                             for (j = 0; j < 201; j++) {
                                 suma_1 = suma_1 + ((pole_Andy[j][i + 2] - pole_Andy[j][1]) * (pole_Andy[j][i + 2] - pole_Andy[j][1]));
                                 suma_2 = suma_2 + pole_Andy[j][1];
                                 }
                             prumer_1 = suma_2 / 201;
                             for (j = 0; j < 201; j++) {
                                 suma_3 = suma_3 + ((pole_Andy[j][1] - prumer_1)*(pole_Andy[j][1] - prumer_1));
                                 }
                             pole_OF[i][2] = 1 - (suma_1 / suma_3); 
                             }                                       
                         pocet_lepsich_CE = 0;
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             if (pole_OF[i][2] >= CE_porov) {
                                pocet_lepsich_CE++;
                                }
                             }
                         printf ("pocet CE vetsich nez %.4f\t: %d\n", CE_porov, pocet_lepsich_CE);
                         /*tisk souboru s poctem prirazenych povodi splnujicich podminku OF*/
                         sprintf (pocet_povodi_CE, "output_data\\output_data_%d\\pocet_povodi_CE.txt", e + 1);
                         f = fopen (pocet_povodi_CE, "a");
                         fprintf (f, "%.0f\t %d\n",deskriptory_UNGAGE[0], pocet_lepsich_CE);
                         fclose(f);
                         /*alokace pole pro povodi s vyssi hodnotou CE nez minimalni definovana*/
                         if ((pole_OF_podminka = ((double**) malloc(pocet_lepsich_CE * sizeof(double *)))) == NULL) {
                            printf ("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         for (k = 0; k < pocet_lepsich_CE; k++) {
                             if ((pole_OF_podminka[k] = ((double*) malloc(3 * sizeof(double)))) == NULL) {
                                printf("chyba pri alokaci pameti\n");
                                return 1;
                                }
                             }
                         k = 0;
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             if (k > pocet_lepsich_CE){
                                break;
                                }
                             if (pole_OF[i][2] >= CE_porov) {
                                for (j = 0; j < 3; j++) {
                                    pole_OF_podminka[k][j] = pole_OF[i][j];
                                    }
                                k++;
                                }                                          
                             }
                         /*alokace pole pro parametry modelu povodi splnujicich podminku OF pro vypocet vazeneho prumeru*/
                         if ((pole_parametru_podminka_CE = ((double**) malloc(pocet_lepsich_CE * sizeof(double *)))) == NULL) {
                            printf ("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         for (k = 0; k < pocet_lepsich_CE; k++) {
                             if ((pole_parametru_podminka_CE[k] = ((double*) malloc((pocet_parametru_modelu + 1) * sizeof(double)))) == NULL) {
                                printf("chyba pri alokaci pameti\n");
                                return 1;
                                }
                             }
                         for (a = 0; a < pocet_radku_parametru; a++) {
                             for (b = 0; b < (pocet_parametru_modelu + 1); b++) {
                                 for (k = 0; k < pocet_lepsich_CE; k++) {
                                     pole_parametru_podminka_CE[k][0] = pole_OF_podminka[k][0];
                                     if (pole_parametru_podminka_CE[k][0] == pole_parametru[a][0]) {                          
                                        for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                                            pole_parametru_podminka_CE[k][b] = pole_parametru[a][b];
                                            }
                                        }                         
                                     }
                                 }
                             }
                         /*tisk pole parametru povodi splnujicich OF pro vypocet vazeneho prumeru*/                                     
                         //sprintf (parametry_povodi, "output_data\\output_data_%d\\pole_parametru_pro_%.0f.txt", e + 1, deskriptory_UNGAGE[0]);
//                         f = fopen (parametry_povodi, "w");
//                         for (k = 0; k < pocet_lepsich_CE; k++) {
//                         for (b = 0; b < (pocet_parametru_modelu + 1); b++) {
//                         fprintf (f, "%f\t", pole_parametru_podminka[k][b]);
//                         }
//                         fprintf (f, "\n");
//                         } 
//                         fclose(f);
                         /*vytvoreni jednorozmerneho pole, kam budou nacteny vazene prumery parametru a vlastni vypocet vazeneho prumeru*/
                         if ((pole_vazeneho_prumeru = ((double*) malloc((pocet_parametru_modelu + 1) * sizeof(double)))) == NULL) {
                            printf("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         pole_vazeneho_prumeru[0] = deskriptory_UNGAGE[0];
                         for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                             vazeny_parametr = suma_vzdalenosti = 0;
                             for (k = 0; k < pocet_lepsich_CE; k++) {
                                 if (pole_OF_podminka[k][1] == 0) {
                                    pole_OF_podminka[k][1] = 0.000000000001;
                                    }   
                                 vazeny_parametr = vazeny_parametr + (pole_parametru_podminka_CE[k][b] * (1 / pole_OF_podminka[k][1]));
                                 suma_vzdalenosti = suma_vzdalenosti + (1 / pole_OF_podminka[k][1]);
                                 }
                             pole_vazeneho_prumeru[b] = vazeny_parametr / suma_vzdalenosti;
                             }
                         /*ulozeni sady optimalnich parametru a vypoctene sady parametru jako vazeny prumer do txt souboru XXX_vazene_parametry.txt*/
                         sprintf (nazev_vazene_parametry_CE, "output_data\\output_data_%d\\%.0f_vazene_parametry_CE.txt", e + 1, deskriptory_UNGAGE[0]);
                         f = fopen (nazev_vazene_parametry_CE, "w");
                         fprintf (f, "optimalni hodnoty parametru modelu pro toto nepozorovane povodi\n");            
                         for (a = 0; a < pocet_radku_parametru; a++) {
                             if (pole_parametru[a][0] == deskriptory_UNGAGE[0]) {
                                for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                                    fprintf(f, "%.4f\t", pole_parametru[a][b]);
                                    }
                                }
                             }             
                         fprintf(f, "\n");                           
                         fprintf (f, "hodnoty parametru modelu vypoctene jako vazeny prumer pro toto nepozorovane povodi\n");             
                         for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                             fprintf(f, "%.4f\t", pole_vazeneho_prumeru[b]);
                             }
                         fprintf(f, "\n");
                         fclose (f);
                         /*vypocet a tisk odchylek parametru VP od optimalnich hodnot*/
                         if ((pole_UNGAGE_parametru = ((double*) malloc((pocet_parametru_modelu + 1) * sizeof(double)))) == NULL) {
                            printf("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         if ((pole_odchylek = ((double*) malloc((pocet_parametru_modelu + 1) * sizeof(double)))) == NULL) {
                            printf("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         pole_UNGAGE_parametru[0] = deskriptory_UNGAGE[0];
                         pole_odchylek[0] = deskriptory_UNGAGE[0];
                         for (a = 0; a < pocet_radku_parametru; a++) {
                             if (pole_parametru[a][0] == pole_UNGAGE_parametru[0]) {
                                for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                                    pole_UNGAGE_parametru[b] = pole_parametru[a][b];
                                    }
                                }
                             }
                         for (b = 1; b < (pocet_parametru_modelu + 1); b++) {
                             pole_odchylek[b] = (pole_vazeneho_prumeru[b] / pole_UNGAGE_parametru[b]) * 100 - 100;
                             if (pole_odchylek[b] < 0) {
                                pole_odchylek[b] = pole_odchylek[b] * -1.0;
                                }
                             }
                         sprintf (celkove_odchylky_CE, "output_data\\output_data_%d\\odchylky_pro_vsechna_ungage_povodi_CE.txt", e + 1);
                         f = fopen (celkove_odchylky_CE, "a");
                         for (b = 0; b < (pocet_parametru_modelu + 1); b++) {
                             fprintf (f, "%.4f\t", pole_odchylek[b]);
                             }
                         fprintf (f, "\n");
                         fclose (f); 
                         /*alokace pole pro Andy krivky povodi splnujicich podminku CE*/
                         if ((pole_Andy_podminka_CE = ((double**) malloc(201 * sizeof(double *)))) == NULL) {
                            printf ("chyba pri alokaci pameti\n");
                            return 1;
                            }
                         for (j = 0; j < 201; j++) {
                             if ((pole_Andy_podminka_CE[j] = ((double*) malloc((pocet_lepsich_CE + 2) * sizeof(double)))) == NULL) {
                                printf("chyba pri alokaci pameti\n");
                                return 1;
                                }
                             }                                                    
                         for (j = 0; j < 201; j++) {
                             pole_Andy_podminka_CE[j][0] = pole_Andy[j][0];
                             pole_Andy_podminka_CE[j][1] = pole_Andy[j][1];
                             }
                         k = 0;
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             if (k > pocet_lepsich_CE){
                                break;
                                }    
                             if (pole_OF[i][2] >= CE_porov) {
                                for (j = 0; j < 201; j++) {
                                    pole_Andy_podminka_CE[j][k + 2] = pole_Andy[j][i + 2];
                                    }
                                k++;    
                                }                                                    
                             }                                                                                              
                         /*tisk dat pro Andrewsovy krivky do souboru data_pro_andy_XXXXXXXXXX.txt*/                         
                         sprintf (data_andy_CE, "output_data\\output_data_%d\\data_pro_andy_CE_%.0f.txt", e + 1, deskriptory_UNGAGE[0]);
                         f = fopen (data_andy_CE, "w");
                         for (j = 0; j < 201; j++) {
                             for (k = 0; k < (pocet_lepsich_CE + 2); k++) {
                                 fprintf (f, "%.3f\t", pole_Andy_podminka_CE[j][k]);
                                 }
                             fprintf (f, "\n");
                             } 
                         fclose(f);
                         /*tisk vzdalenosti a CE do souboru vzdalenosti_CE_XXXXXXXXX.txt*/
                         sprintf (dist_CE, "output_data\\output_data_%d\\distance_CE_%.0f.txt", e + 1, deskriptory_UNGAGE[0]);
                         f = fopen (dist_CE, "w");
                         for (k = 0; k < pocet_lepsich_CE; k++) {
                             for (j = 0; j < 3; j++) {
                                 fprintf (f, "%f\t", pole_OF_podminka[k][j]);
                                 }
                             fprintf (f, "\n");
                             }
                         fclose(f);
                         /*vytvoreni GNU souboru pro vykreselni Andrewsovych krivek*/
                         sprintf (andy_graf_CE, "output_data\\output_data_%d\\%.f_AND_krivky_graf_CE.GNU", e + 1, deskriptory_UNGAGE[0]);
                         f = fopen (andy_graf_CE, "w");
                         fprintf (f, "set grid\n");
                         fprintf (f,"set key samplen 1\n");
                         fprintf (f,"set key width 0.05\n");
                         fprintf (f,"set key height 0.5\n");
                         fprintf (f,"set key outside below\n");
                         fprintf (f,"set xrange [-3.14:3.14]\n");
                         fprintf (f,"set xtics %f\n", 3.14 / 5);
                         //fprintf (f,"set yrange [0:1]\n");
                         //fprintf (f,"set ytics %f\n", 0.2);
                         fprintf (f,"plot 'C:\\invers_shluk\\output_data\\output_data_%d\\data_pro_andy_CE_%.0f.txt' u 1:3 w steps title 'gauged catchments' lt 9\n", e + 1, deskriptory_UNGAGE[0]);
                         for (i = 4; i < (pocet_lepsich_CE + 3); i++) {
                             fprintf (f,"replot 'C:\\invers_shluk\\output_data\\output_data_%d\\data_pro_andy_CE_%.0f.txt' u 1:%d w steps title '' lt 9\n", e + 1, deskriptory_UNGAGE[0], i);
                             }    
                         fprintf (f,"replot 'C:\\invers_shluk\\output_data\\output_data_%d\\data_pro_andy_CE_%.0f.txt' u 1:2 w steps title 'ungauged catchment' lt -1 lw 2\n", e + 1, deskriptory_UNGAGE[0]);         
                         fprintf (f, "set out '%.f_AND_krivky_graf_CE.ps'\n", deskriptory_UNGAGE[0]);
                         fprintf (f, "set t post solid enhanced color\n");
                         fprintf (f, "replot\n");
                         fprintf (f, "set out\n");
                         fprintf (f, "set t windows\n");
                         fclose(f);
                         for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                             free((void*) pole_OF[i]);
                             }
                         free((void*) pole_OF); 
                         pole_OF = NULL;
                         for (k = 0; k < pocet_lepsich_CE; k++) {
                             free((void*) pole_OF_podminka[k]);
                             }
                         free((void*) pole_OF_podminka); 
                         pole_OF_podminka = NULL;    
                         for (k = 0; k < pocet_lepsich_CE; k++) {
                             free((void*) pole_parametru_podminka_CE[k]);
                             }
                         free((void*) pole_parametru_podminka_CE); 
                         pole_parametru_podminka_CE = NULL;                                                                          
                         for (j = 0; j < 201; j++) {
                             free((void*) pole_Andy_podminka_CE[j]);
                             }
                         free((void*) pole_Andy_podminka_CE); 
                         pole_Andy_podminka_CE = NULL;                                                  
                         free((void*) pole_vazeneho_prumeru);
                         pole_vazeneho_prumeru = NULL;                         
                         free((void*) pole_UNGAGE_parametru);
                         pole_UNGAGE_parametru = NULL;                         
                         free((void*) pole_odchylek);
                         pole_odchylek = NULL;
                         break;                                                  
                 }                                                                                                         
             for (i = 0; i < pocet_minimalnich_vzdalenosti; i++) {
                 free((void*) pole_deskriptoru_GAGE_povodi_podminka[i]);
                 }
             free((void*) pole_deskriptoru_GAGE_povodi_podminka); 
             pole_deskriptoru_GAGE_povodi_podminka = NULL;
             for (j = 0; j < 201; j++) {
                 free((void*) pole_Andy[j]);
                 }
             free((void*) pole_Andy); 
             pole_Andy = NULL;
             }                                            
         }                                     
    system ("PAUSE");
    return 0;
}
